<!DOCTYPE html>
<html>

<head>
    <meta charset="UTF-8">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.16.0/umd/popper.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>
<!-- file html dùng để thử tác động của javascript vào các thành phần trang web-->
<script>
    'use strict';
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
	const gREQUEST_STATUS_CREATED = 201;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gBASE_URL = "https://62458c222cfed18817229118.mockapi.io/users";
	const gBASE_URL_CONTACTS = "https://62458c222cfed18817229118.mockapi.io/contacts";
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    //gọi mẫu lấy api login
    function onBtnLoginClick() {
        "use strict";
        //base url
        const vParams = new URLSearchParams({
          username: "username 21",
		  password: "password 21",
		});
        // create a request
        var vXmlHttpLogin = new XMLHttpRequest();
        vXmlHttpLogin.open("GET", gBASE_URL + "?" + vParams.toString(), true);
        vXmlHttpLogin.send();
        vXmlHttpLogin.onreadystatechange =
            function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                    var vLoginInfo = vXmlHttpLogin.responseText;
                    console.log(vLoginInfo);
                }
            }
    }

    //gọi mẫu lấy api singup
    function onBtnSignUpClick() {
        "use strict";
        //base url
        var vData = JSON.stringify({
			fullname: "devcamp",
			username: "devcamp",
			password: "devcamp"
		});
		
        var vXmlHttpSignUp = new XMLHttpRequest();
        vXmlHttpSignUp.open("POST", gBASE_URL, true);
        vXmlHttpSignUp.send(vData);
        vXmlHttpSignUp.onreadystatechange =
            function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_CREATED) {
                    var vVoucherSignUp = vXmlHttpSignUp.responseText;
                    console.log(vVoucherSignUp);
                }
            }
    }

    //gọi mẫu lấy api create contact
    function onBtnCreateContactClick() {
        "use strict";
        //base url
        var vData = JSON.stringify({
			name: "Minh",
			  email: "mình@gmail.com",
			  contact: "Xin chào"
		});

        var vXmlHttpCreateContact = new XMLHttpRequest();
        vXmlHttpCreateContact.open("POST", gBASE_URL_CONTACTS, true);
        vXmlHttpCreateContact.send(vData);
        vXmlHttpCreateContact.onreadystatechange =
            function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_CREATED) {
                    console.log(vXmlHttpCreateContact.responseText);
                }
            }
    }
/*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/

</script>

<body>
    <div class="container">
        <div class="form-group">
            <p id="cmt2dev">Test Page for Javascrip Tasks. F5 to run code. </p>
        </div>
        <div class="form-group">
                <input type="button" class="btn btn-info" onclick="onBtnLoginClick()"
                    value="Call api login!">
                <input type="button" class="btn btn-warning" onclick="onBtnSignUpClick()"
                    value="Call api signup!">
                <input type="button" class="btn btn-success" onclick="onBtnCreateContactClick()"
                    value="Call create contact!">
        </div>
        <div class="row form-group">
            <ul>
                <li>api login: API Đăng nhập</li>
                <li>api signup: API Đăng ký</li>
                <li>post api contact: Tạo contact</li>
            </ul>
        </div>
    </div>
</body>

</html>